package org.w3c.rdfpic;
import org.w3c.rdfpic.ui.*;
import org.w3c.rdfpic.core.*;
import java.net.URL;
import java.net.MalformedURLException;

/**
 * Rdfpic is a program to attach meta-data to images (currently jpeg's).
 * It is split up into two parts, the UI, and the core.  Class Main initializes
 * those two parts to work with each other, and selects any files listed on the
 * command line.
 * @author Eamon Nerbonne
 * @version 2.0
 */
public class Main
{
    /**
     * Loads the UI (SimpleUI) and the core (RdfPicCore) and loads the files
     * listed on the command line
     * @param args The command line arguments.
     */
    public static void main(String[] args) throws Exception
    {
	URL[] schemas,pics;
	schemas = new URL[2];
	schemas[0] = Main.class.getResource("DC.schema");
	schemas[1] = Main.class.getResource("Technical.schema");
	pics = new URL[args.length];
	for(int i=0;i<args.length;i++) 
	    {
		try {
		    pics[i]=new URL(args[i]);
		} catch (MalformedURLException mue) {
		    pics[i]=new URL("file","",args[i]);
		}
	    }
	if(System.getProperty("org.xml.sax.parser") == null) {
	    System.getProperties().put("org.xml.sax.parser", "com.microstar.xml.SAXDriver");
	}
	RdfPicCore core = new RdfPicCore(new SchemaTxtDrv(),schemas,pics);
	SimpleUI ui = new SimpleUI();
	ui.go(core);
    }
}
