package org.w3c.rdfpic.core;
import java.io.IOException;
import java.net.URL;
/**
 * A class implementing SchemaFileDrv should be able to serialize and parse some
 * format for storing schema definitions into the format used internally, RdfSchema.
 */

public interface SchemaFileDrv
{
    /**
     * set the url of the schema definition file
     */
    public void setURL(URL url) throws IOException;
    /**
     * reads a schema definition from a file
     */
    public RdfSchema read() throws IOException;
    /**
     * writes (overwrites) a schema definition to a file
     */
    public void write(RdfSchema schema) throws IOException;
    public Object clone();
}
