
package org.w3c.rdfpic.ui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.net.URL;

/**
 * A simple dialog that shows the authors of rdfpic.
 */
public class AboutFrame {

    /**
     * The "about" message.
     */
    static String [] msg = {
	"rdfpic is a Koala/W3C project - Copyright (c) 2000-2001",
	" ",
	"Authors :",
	"Eamon Nerbonne (eamon@dds.nl)",
	" ",
	"Contributors :",
	"Thierry Kormann (Thierry.Kormann@sophia.inria.fr)",
	"Bert Bos (bert@w3.org)",
	"Yves Lafon (ylafon@w3.org)",
	"Colas Nahaboo (Colas.Nahaboo@sophia.inria.fr)"
    };


    /**
     * Shows the "about" message.
     * @param bg The "parent" component creating the message (generally a SimpleUI instance).
     */
    public static void show(Component bg) {
	JPanel panel = new JPanel(new GridBagLayout());
        GridBagConstraints constraints = new GridBagConstraints();
        constraints.insets = new Insets(10, 10, 10, 10);
	constraints.weightx = 0;
        constraints.weighty = 0;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
	constraints.anchor = GridBagConstraints.NORTHEAST;
	constraints.fill = GridBagConstraints.NONE;
	constraints.gridx = 0;
	constraints.gridy = 0;

	URL url = AboutFrame.class.getResource("icons/koala.gif");
	panel.add(new JLabel(new ImageIcon(url)), constraints);
	constraints.gridy = 1;
	url = AboutFrame.class.getResource("icons/w3c.gif");
	panel.add(new JLabel(new ImageIcon(url)), constraints);


	constraints.gridx = 1;
	constraints.gridy = 0;
        constraints.gridheight = 2;

	panel.add(getAboutText(), constraints);
	JOptionPane.showMessageDialog(bg,panel,SimpleUI.titleStr+" : About...",JOptionPane.PLAIN_MESSAGE,null);
    }

    /**
     * Returns the message as a displayable UI component.
     */
    private static JComponent getAboutText() {
	JPanel panel = new JPanel(new GridBagLayout());

        GridBagConstraints constraints = new GridBagConstraints();
	constraints.weightx = 0;
        constraints.weighty = 0;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
	constraints.anchor = GridBagConstraints.CENTER;
	constraints.fill = GridBagConstraints.NONE;
	constraints.gridx = 0;
	for (int i=0; i < msg.length; ++i) {
	    constraints.gridy = i;
	    panel.add(new JLabel(msg[i]), constraints);
	}
	return panel;
    }
}
