package org.w3c.rdfpic.ui;
import javax.swing.JComponent;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Dimension;

/**
 * Scales pictures to fit without changing the aspect ratio, using ScalableImageIcon.
 */
public class ScaledPhoto extends JComponent {

    ScalableImageIcon imgIcon;
    String text;
    /**
     *Sets the image that should be displayed
     */
    public void setIcon(ScalableImageIcon imgIcon) 
    {
	this.imgIcon = imgIcon;
	repaint();
    }
    /**
     * Sets the text to display when there is no icon set.
     */
    public void setAlt(String text)
    {
	this.text=text;
    }
    public Dimension getPreferredSize()
    {
	return new Dimension(320,240); 
    }
    public void paintComponent(Graphics g) 
    {
       	super.paintComponent(g);
	Dimension dim = getSize();
	Insets insets = getInsets();
	if(imgIcon==null)//no Image  AHH!.
	    {
		if(text!=null) g.drawString(text,insets.left+1,(dim.height-insets.bottom+insets.top)/2);
		return;
	    }
	int x = insets.left;
	int y = insets.top;
	int iw = imgIcon.getIconWidth();
	int ih = imgIcon.getIconHeight();
	int w,h,dw,dh;
	dw=dim.width-insets.left-insets.right;
	dh=dim.height-insets.top-insets.bottom;
	if (dw > (iw*dh)/ih) // if we scale image so that w=dw or h=dh, we can
	    {	             //can choose the smaller one.  when h=dh i.e.
		w=(iw*dh)/ih;//h = (dh/ih) ih; then w = (dh/ih) iw.
		h=dh;
	    }
	else 
	    {
		w = dw;
		h = (ih*dw)/iw;
	    }
	imgIcon.paintIcon(g, insets.left/*x*/, insets.top/*y*/,
			  w, h, getBackground());
    }
}


